searchNodes=[{"doc":"Customizable file traverser.","ref":"DeepSinker.html","title":"DeepSinker","type":"module"},{"doc":"Create initial state. Examples iex&gt; DeepSinker . new ( [ &quot;/path/to/dir1&quot; , &quot;/path/to/dir2&quot; ] ) ...&gt; |&gt; is_struct ( DeepSinker ) true iex&gt; DeepSinker . new ( [ &quot;/path/to/dir1&quot; , &quot;/path/to/dir2&quot; ] , order : :desc ) ...&gt; |&gt; is_struct ( DeepSinker ) true","ref":"DeepSinker.html#new/2","title":"DeepSinker.new/2","type":"function"},{"doc":"Pop file and update state. Examples iex&gt; DeepSinker . new ( [ &quot;./&quot; ] ) ...&gt; |&gt; DeepSinker . next ( ) ...&gt; # {state, {:ok, filepath}} | {state, :done} iex&gt; DeepSinker . new ( [ &quot;./&quot; ] ) ...&gt; |&gt; DeepSinker . next ( ...&gt; handler : fn item_path -&gt; ...&gt; cond do ...&gt; String . ends_with? ( item_path , &quot;.git&quot; ) -&gt; :ignore ...&gt; String . contains? ( item_path , &quot;.&quot; ) -&gt; :file ...&gt; true -&gt; :directory ...&gt; end ...&gt; end ...&gt; ) ...&gt; # {state, {:ok, filepath}} | {state, :done}","ref":"DeepSinker.html#next/2","title":"DeepSinker.next/2","type":"function"},{"doc":"Stream filepaths. Examples iex&gt; DeepSinker . new ( [ &quot;./&quot; ] ) ...&gt; # |&gt; DeepSinker.stream() ...&gt; # |&gt; Enum.to_list() ...&gt; # [&quot;list&quot;, &quot;of&quot; &quot;filepaths&quot;] iex&gt; DeepSinker . new ( [ &quot;./&quot; ] ) ...&gt; |&gt; DeepSinker . stream ( ...&gt; handler : fn item_path -&gt; ...&gt; cond do ...&gt; String . ends_with? ( item_path , &quot;.git&quot; ) -&gt; :ignore ...&gt; String . contains? ( item_path , &quot;.&quot; ) -&gt; :file ...&gt; true -&gt; :directory ...&gt; end ...&gt; end ...&gt; ) ...&gt; # [&quot;list&quot;, &quot;of&quot; &quot;filepaths&quot;]","ref":"DeepSinker.html#stream/2","title":"DeepSinker.stream/2","type":"function"},{"doc":"","ref":"DeepSinker.html#t:filepath/0","title":"DeepSinker.filepath/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:handler/0","title":"DeepSinker.handler/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:item_path/0","title":"DeepSinker.item_path/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:item_type/0","title":"DeepSinker.item_type/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:new_option/0","title":"DeepSinker.new_option/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:next_option/0","title":"DeepSinker.next_option/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:next_result/0","title":"DeepSinker.next_result/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:order/0","title":"DeepSinker.order/0","type":"type"},{"doc":"State of traversing.","ref":"DeepSinker.html#t:t/0","title":"DeepSinker.t/0","type":"type"},{"doc":"Customizable directory traverser.","ref":"readme.html","title":"DeepSinker","type":"extras"},{"doc":"# Default usage state = DeepSinker . new ( [ &quot;/path/to/dir1&quot; , &quot;/path/to/dir2&quot; ] ) DeepSinker . next ( state ) # {new_state, {:ok, filepath} | :done} # Custom usage state = DeepSinker . new ( [ &quot;/path/to/dir1&quot; , &quot;/path/to/dir2&quot; ] , order : :desc ) # :asc or :desc DeepSinker . next ( state , handler : fn item_path -&gt; # Below code is default handler but File.dir?/1 consume large time in some env. # cond do # File.dir?(item_path) -&gt; :directory # true -&gt; :file # end # If you want to avoid File.dir?/1, use this. basename = Path . basename ( item_path ) cond do basename == &quot;.git&quot; -&gt; :ignore String . contains? ( basename , &quot;.&quot; ) -&gt; :file true -&gt; :directory end end ) # {new_state, {:ok, filepath} | :done} # Stream usage state = DeepSinker . new ( [ &quot;/path/to/dir1&quot; , &quot;/path/to/dir2&quot; ] ) DeepSinker . stream ( state ) |&gt; Enum . to_list ( ) # [filepath]","ref":"readme.html#usage","title":"DeepSinker - Usage","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding deep_sinker to your list of dependencies in mix.exs : def deps do [ { :deep_sinker , &quot;~&gt; 1.0.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/deep_sinker .","ref":"readme.html#installation","title":"DeepSinker - Installation","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Changed Change to take handler when next/2 instead of new/2 . Fixed Fix type specs.","ref":"changelog.html#1-0-0-2023-06-24","title":"Changelog - 1.0.0 - 2023-06-24","type":"extras"},{"doc":"Fixed Fix traversing.","ref":"changelog.html#0-2-0-2023-04-12","title":"Changelog - 0.2.0 - 2023-04-12","type":"extras"},{"doc":"Fixed Fix document Fix typespec of DeepSinker.stream .","ref":"changelog.html#0-1-2-2023-04-11","title":"Changelog - 0.1.2 - 2023-04-11","type":"extras"},{"doc":"Fixed Add ex_doc .","ref":"changelog.html#0-1-1-2023-04-11","title":"Changelog - 0.1.1 - 2023-04-11","type":"extras"},{"doc":"Added Initial release.","ref":"changelog.html#0-1-0-2023-04-11","title":"Changelog - 0.1.0 - 2023-04-11","type":"extras"}]